/**
 * ResultCode.java
 *
 * File generated from the core::ResultCode uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.hpd;

// End of user code
import java.util.List;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import net.ihe.gazelle.gen.common.ConstraintValidatorModule;

import org.w3c.dom.Document;
import org.w3c.dom.Node;


/**
 * Description of the class ResultCode.
 *
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "ResultCode", propOrder = {
	"code",
	"descr"
})
@XmlRootElement(name = "ResultCode")
public class ResultCode implements java.io.Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	
	@XmlAttribute(name = "code", required = true)
	@javax.xml.bind.annotation.adapters.XmlJavaTypeAdapter(net.ihe.gazelle.adapters.IntegerAdapter.class)
	public Integer code;
	@XmlAttribute(name = "descr")
	public net.ihe.gazelle.hpd.LDAPResultCode descr;
	
	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	private org.w3c.dom.Node _xmlNodePresentation;
	
	
	/**
	 * Return code.
	 * @return code
	 */
	public Integer getCode() {
	    return code;
	}
	
	/**
	 * Set a value to attribute code.
	 * @param code.
	 */
	public void setCode(Integer code) {
	    this.code = code;
	}
	
	
	
	
	/**
	 * Return descr.
	 * @return descr
	 */
	public net.ihe.gazelle.hpd.LDAPResultCode getDescr() {
	    return descr;
	}
	
	/**
	 * Set a value to attribute descr.
	 * @param descr.
	 */
	public void setDescr(net.ihe.gazelle.hpd.LDAPResultCode descr) {
	    this.descr = descr;
	}
	
	
	
	
	
	public Node get_xmlNodePresentation() {
		if (_xmlNodePresentation == null){
				JAXBContext jc;
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				dbf.setNamespaceAware(true);
				DocumentBuilder db = null;
				Document doc = null;
				try {
					db = dbf.newDocumentBuilder();
					doc = db.newDocument();
				} catch (ParserConfigurationException e1) {}
				try {
					jc = JAXBContext.newInstance("net.ihe.gazelle.hpd");
					Marshaller m = jc.createMarshaller();
					m.marshal(this, doc);
					_xmlNodePresentation = doc.getElementsByTagNameNS("urn:oasis:names:tc:DSML:2:0:core", "ResultCode").item(0);
				} catch (JAXBException e) {
					try{
						db = dbf.newDocumentBuilder();
						_xmlNodePresentation = db.newDocument();
					}
					catch(Exception ee){}
				}
			}
			return _xmlNodePresentation;
	}
	
	public void set_xmlNodePresentation(Node _xmlNodePresentation) {
		this._xmlNodePresentation = _xmlNodePresentation;
	}
	
	
	

	
	/**
     * validate by a module of validation
     * 
     */
   public static void validateByModule(ResultCode resultCode, String _location, ConstraintValidatorModule cvm, List<net.ihe.gazelle.validation.Notification> diagnostic){
   		if (resultCode != null){
   			cvm.validate(resultCode, _location, diagnostic);
    	}
    }

}